/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/*
 * ListSelector.java
 *
 * Created on 02-may-2009, 13:50:41
 */

package es.uca.takuan.netbeans.wizard;

import java.io.File;
import javax.swing.DefaultListModel;
import javax.swing.JFileChooser;

/**
 *
 * @author alejandro
 */
public class ListSelector extends javax.swing.JDialog {

    private boolean accept;

    /** Creates new form ListSelector */
    public ListSelector(java.awt.Frame parent, boolean modal) {
        super(parent, modal);
        initComponents();
        accept = false;
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jScrollPane1 = new javax.swing.JScrollPane();
        lstFiles = new javax.swing.JList();
        jButton1 = new javax.swing.JButton();
        jButton2 = new javax.swing.JButton();
        cmdAddExternal = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle(org.openide.util.NbBundle.getMessage(ListSelector.class, "ListSelector.title")); // NOI18N

        lstFiles.setModel(new DefaultListModel());
        jScrollPane1.setViewportView(lstFiles);

        jButton1.setText(org.openide.util.NbBundle.getMessage(ListSelector.class, "CANCEL")); // NOI18N
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cancelActionPerformed(evt);
            }
        });

        jButton2.setText(org.openide.util.NbBundle.getMessage(ListSelector.class, "ACCEPT")); // NOI18N
        jButton2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                acceptActionPerformed(evt);
            }
        });

        cmdAddExternal.setText(org.openide.util.NbBundle.getMessage(ListSelector.class, "ListSelector.cmdAddExternal.text")); // NOI18N
        cmdAddExternal.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cmdAddExternalActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(jScrollPane1, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 317, Short.MAX_VALUE)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(cmdAddExternal)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 48, Short.MAX_VALUE)
                        .addComponent(jButton2)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jButton1)))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 202, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jButton1)
                    .addComponent(jButton2)
                    .addComponent(cmdAddExternal))
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void cancelActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cancelActionPerformed
        accept = false;
        setVisible(false);
    }//GEN-LAST:event_cancelActionPerformed

    private void acceptActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_acceptActionPerformed
        accept = true;
        setVisible(false);
    }//GEN-LAST:event_acceptActionPerformed

    /**
     * Adds a external file
     * @param evt
     */
    private void cmdAddExternalActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cmdAddExternalActionPerformed
        JFileChooser selectDialog = new JFileChooser();

        selectDialog.setMultiSelectionEnabled(true);

        if(selectDialog.showOpenDialog(this) == JFileChooser.APPROVE_OPTION)
        {
            File[]           files  = selectDialog.getSelectedFiles();
            DefaultListModel model  = (DefaultListModel) lstFiles.getModel();
            int              pos    = model.getSize();

            for(File f : files) {
                model.add(pos, f.getAbsolutePath());
                lstFiles.setSelectedIndex(pos);
            }
        }
    }//GEN-LAST:event_cmdAddExternalActionPerformed

    public boolean accepted() {
        return accept;
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton cmdAddExternal;
    private javax.swing.JButton jButton1;
    private javax.swing.JButton jButton2;
    private javax.swing.JScrollPane jScrollPane1;
    public javax.swing.JList lstFiles;
    // End of variables declaration//GEN-END:variables

}
